﻿using DefaultValueIsBroken.Models;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace DefaultValueIsBroken.Controllers
{
    public class HomeController : Controller
    {
        public JsonResult ReadMembers()
        {
            var model = new List<GroupMemberViewModel>();

            model.Add(new GroupMemberViewModel()
            {
                Id = 1,
                Name = "Joe"
            });

            model.Add(new GroupMemberViewModel()
            {
                Id = 2,
                Name = "Bob"
            });

            model.Add(new GroupMemberViewModel()
            {
                Id = 3,
                Name = "John"
            });

            model.Add(new GroupMemberViewModel()
            {
                Id = 4,
                Name = "Current User"
            });

            return Json(model, JsonRequestBehavior.AllowGet);
        }

        public JsonResult Read([DataSourceRequest] DataSourceRequest request)
        {
            var model = new List<GroupViewModel>();

            model.Add(new GroupViewModel()
            {
                Id = 1,
                Name = "Default",
                Members = new List<GroupMemberViewModel>()
                {
                    new GroupMemberViewModel()
                    {
                        Id = 1,
                        Name = "Joe"
                    }
                }
            });

            model.Add(new GroupViewModel()
            {
                Id = 2,
                Name = "Value",
                Members = new List<GroupMemberViewModel>()
                {
                    new GroupMemberViewModel()
                    {
                        Id = 2,
                        Name = "Is"
                    }
                }
            });

            model.Add(new GroupViewModel()
            {
                Id = 3,
                Name = "Is",
                Members = new List<GroupMemberViewModel>()
                {
                    new GroupMemberViewModel()
                    {
                        Id = 2,
                        Name = "Bob"
                    }
                }
            });

            model.Add(new GroupViewModel()
            {
                Id = 4,
                Name = "Broken",
                Members = new List<GroupMemberViewModel>()
                {
                    new GroupMemberViewModel()
                    {
                        Id = 3,
                        Name = "John"
                    },
                    new GroupMemberViewModel()
                    {
                        Id = 4,
                        Name = "Current User"
                    }
                }
            });

            return Json(model.ToDataSourceResult(request), JsonRequestBehavior.AllowGet);
        }

        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC!";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}
